# swagger_client.AttributeApi

All URIs are relative to *https://api.newsletter2go.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_attribute**](AttributeApi.md#create_attribute) | **POST** /attributes | creates a new attribute
[**delete_attribute**](AttributeApi.md#delete_attribute) | **DELETE** /lists/{lid}/attributes/{id} | delete the attribute
[**get_attributes**](AttributeApi.md#get_attributes) | **GET** /lists/{lid}/attributes | get all Attributes of selected list
[**update_attribute**](AttributeApi.md#update_attribute) | **PATCH** /attributes/{id} | update the attribute


# **create_attribute**
> ApiResponsePost create_attribute(attribute)

creates a new attribute

creates a new attribute.

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.AttributeApi()
attribute = swagger_client.AttributePost() # AttributePost | the data to save

try: 
    # creates a new attribute
    api_response = api_instance.create_attribute(attribute)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling AttributeApi->create_attribute: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **attribute** | [**AttributePost**](AttributePost.md)| the data to save | 

### Return type

[**ApiResponsePost**](ApiResponsePost.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_attribute**
> ApiResponseDelete delete_attribute(lid, id)

delete the attribute

delete one attribute

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.AttributeApi()
lid = 'lid_example' # str | the id of the list
id = 'id_example' # str | the id of the attribute

try: 
    # delete the attribute
    api_response = api_instance.delete_attribute(lid, id)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling AttributeApi->delete_attribute: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **id** | **str**| the id of the attribute | 

### Return type

[**ApiResponseDelete**](ApiResponseDelete.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_attributes**
> AttributeResponse get_attributes(lid, filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)

get all Attributes of selected list

get Attributes

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.AttributeApi()
lid = 'lid_example' # str | the id of the list
filter = 'filter_example' # str | a FIQL-Filter (optional)
limit = 50 # int | a limit for list-responses (optional) (default to 50)
offset = 0 # int | an offset for list-responses (optional) (default to 0)
expand = true # bool | true if attributes should be returned or not (optional)
fields = ['fields_example'] # list[str] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

try: 
    # get all Attributes of selected list
    api_response = api_instance.get_attributes(lid, filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling AttributeApi->get_attributes: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **filter** | **str**| a FIQL-Filter | [optional] 
 **limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **expand** | **bool**| true if attributes should be returned or not | [optional] 
 **fields** | [**list[str]**](str.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**AttributeResponse**](AttributeResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_attribute**
> PatchResponse update_attribute(id, attribute)

update the attribute

update one attribute

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.AttributeApi()
id = 'id_example' # str | the id of the attribute
attribute = swagger_client.AttributePatch() # AttributePatch | the data to update

try: 
    # update the attribute
    api_response = api_instance.update_attribute(id, attribute)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling AttributeApi->update_attribute: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| the id of the attribute | 
 **attribute** | [**AttributePatch**](AttributePatch.md)| the data to update | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

