# swagger_client.ListApi

All URIs are relative to *https://api.newsletter2go.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_list**](ListApi.md#create_list) | **POST** /lists | creates a new list
[**delete_list**](ListApi.md#delete_list) | **DELETE** /lists/{id} | delete the List
[**get_lists**](ListApi.md#get_lists) | **GET** /lists | get all lists
[**get_recipients**](ListApi.md#get_recipients) | **GET** /lists/{lid}/recipients | get all Recipients of selected list
[**remove_recipients_from_list**](ListApi.md#remove_recipients_from_list) | **DELETE** /lists/{lid}/recipients | remove all Recipients from selected list
[**update_list**](ListApi.md#update_list) | **PATCH** /lists/{id} | update the List
[**update_recipients**](ListApi.md#update_recipients) | **PATCH** /lists/{lid}/recipients | update all Recipients in selected list


# **create_list**
> ApiResponsePost create_list(list)

creates a new list

creates a new List

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.ListApi()
list = swagger_client.ListPost() # ListPost | the data to save

try: 
    # creates a new list
    api_response = api_instance.create_list(list)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling ListApi->create_list: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **list** | [**ListPost**](ListPost.md)| the data to save | 

### Return type

[**ApiResponsePost**](ApiResponsePost.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_list**
> ApiResponseDelete delete_list(id)

delete the List

delete one List

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.ListApi()
id = 'id_example' # str | the id of the list

try: 
    # delete the List
    api_response = api_instance.delete_list(id)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling ListApi->delete_list: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| the id of the list | 

### Return type

[**ApiResponseDelete**](ApiResponseDelete.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_lists**
> ListResponse get_lists(filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)

get all lists

get Lists

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.ListApi()
filter = 'filter_example' # str | a FIQL-Filter (optional)
limit = 50 # int | a limit for list-responses (optional) (default to 50)
offset = 0 # int | an offset for list-responses (optional) (default to 0)
expand = true # bool | true if attributes should be returned or not (optional)
fields = ['fields_example'] # list[str] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

try: 
    # get all lists
    api_response = api_instance.get_lists(filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling ListApi->get_lists: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **filter** | **str**| a FIQL-Filter | [optional] 
 **limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **expand** | **bool**| true if attributes should be returned or not | [optional] 
 **fields** | [**list[str]**](str.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**ListResponse**](ListResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_recipients**
> RecipientResponse get_recipients(lid, filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)

get all Recipients of selected list

Get Recipients. If the API shall return custom attributes also, submit them in the _fields-Parameter by name.

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.ListApi()
lid = 'lid_example' # str | the id of the list
filter = 'filter_example' # str | a FIQL-Filter (optional)
limit = 50 # int | a limit for list-responses (optional) (default to 50)
offset = 0 # int | an offset for list-responses (optional) (default to 0)
expand = true # bool | true if attributes should be returned or not (optional)
fields = ['fields_example'] # list[str] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

try: 
    # get all Recipients of selected list
    api_response = api_instance.get_recipients(lid, filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling ListApi->get_recipients: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **filter** | **str**| a FIQL-Filter | [optional] 
 **limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **expand** | **bool**| true if attributes should be returned or not | [optional] 
 **fields** | [**list[str]**](str.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**RecipientResponse**](RecipientResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **remove_recipients_from_list**
> PatchResponse remove_recipients_from_list(lid, filter=filter)

remove all Recipients from selected list

remove Recipients from selected list. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting removed!

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.ListApi()
lid = 'lid_example' # str | the id of the list
filter = 'filter_example' # str | a FIQL-Filter (optional)

try: 
    # remove all Recipients from selected list
    api_response = api_instance.remove_recipients_from_list(lid, filter=filter)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling ListApi->remove_recipients_from_list: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **filter** | **str**| a FIQL-Filter | [optional] 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_list**
> PatchResponse update_list(id, list)

update the List

update one List

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.ListApi()
id = 'id_example' # str | the id of the list
list = swagger_client.ListPost() # ListPost | the data to update

try: 
    # update the List
    api_response = api_instance.update_list(id, list)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling ListApi->update_list: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| the id of the list | 
 **list** | [**ListPost**](ListPost.md)| the data to update | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_recipients**
> PatchResponse update_recipients(lid, filter=filter)

update all Recipients in selected list

Updates all recipients in the given list where the filter applies. If a value of a custom attribute shall by changed just submit it in the json body. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting updated!

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.ListApi()
lid = 'lid_example' # str | the id of the list
filter = 'filter_example' # str | a FIQL-Filter (optional)

try: 
    # update all Recipients in selected list
    api_response = api_instance.update_recipients(lid, filter=filter)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling ListApi->update_recipients: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **filter** | **str**| a FIQL-Filter | [optional] 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

